defmodule DrainCloudCore.Auth.SessionsStore do
  @behaviour Plug.Session.Store

  @token_len 64

  alias DrainCloudCore.Auth.SessionsRepo
  alias DrainCloudCore.Repo, as: Repo

  def init(_opts), do: :ok

  def put(conn, sid, any, opts) do

  end

  def get(conn, cookie, opts) do

  end

  def delete(conn, sid, opts) do

  end

  def new_session(conn, user) do
    %DrainCloudCore.Auth.Session {
      user_id: user.id,
      token: new_token(@token_len),
      user_agent: user_agent(conn),
      created_at: DateTime.utc_now(),
      expires_at: DateTime.add(DateTime.utc_now(), 7*24, :hour)
    }
  end

  defp user_agent(conn) do
    Enum.find_value(conn.req_headers, "", fn x ->
      case x do
        {"user-agent", agent} -> agent
        _ -> nil
      end
    end)
  end

  defp new_token(length) do
    :crypto.strong_rand_bytes(length) |> Base.url_encode64 |> binary_part(0, length)
  end
end
